      program bfs_mb_turb
c=======================================================================
c
c     programmer      Kees Kassels
c
c     version  1.0    date    25-03-94
c
c   copyright (c) 1994  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c***********************************************************************
c
c                    DESCRIPTION
c
c     ISNaS Host Program
c
c***********************************************************************
c
c                   KEYWORDS
c
c     host_program
c
c***********************************************************************
c
c                   INPUT / OUTPUT PARAMETERS
c
      implicit none
c***********************************************************************
c
c                   COMMON BLOCKS
c
      integer nbuffr
      parameter( nbuffr = 8000000 )
      integer ibuffr
      common ibuffr(nbuffr)
c
c     IBUFFR    Integer buffer array in which all array information
c               with respect to the ISNaS software is stored.
c
c     NBUFFR    Declared length of IBUFFR
c
c
c***********************************************************************
c
c                   LOCAL PARAMETERS
c
c
c***********************************************************************
c
c                   SUBROUTINES CALLED
c
c     ISHMAIN    ISNaS host main subroutine
c
c***********************************************************************
c
c                   I/O
c
c***********************************************************************
c
c                   ERROR MESSAGES
c
c***********************************************************************
c
c                   PSEUDO CODE
c
c          initialize local buffer
c          call ISNaS host main subroutine
c
c=======================================================================

      call ismain( nbuffr )

      end
      subroutine inlees ( ar )

      implicit none      

      double precision ar(1:4,1:81)
      integer i
      
      open (11, file='bfs_mb_turb.dat')

      read(11,'(a)')
      do 10 i = 1, 81
        read(11,*) ar(1,i), ar(2,i), ar(3,i), ar(4,i)
10    continue

      close(11)
      end
      function usfunb ( ichoice, x, y, z, t )

c     User written function subroutine. It gives
c     the user the opportunity to define a
c     boundary condition as a function of space
c     and time.

      implicit none      

      double precision usfunb, x, y, z, t
      integer ichoice

c     x        i    x-coordinate 
c     y        i    y-coordinate 
c     t        i    actual time 
c     ichoice  i    choice parameter given by the user input
c     usfunb   o    computed boundary condition

      logical ready
      integer i
      double precision ar(1:4,1:81), y1, y2, u1, u2, k1, k2, 
     +                 e1, e2, a1, b1, a2, b2,  a3, b3, u, k,
     +                 eps

      call inlees( ar )

      ready = .false.
      i = 1
      do while ( .not. ready .and. i .le. 80)

        y1 = ar(1,i)
        y2 = ar(1,i+1)
        u1 = ar(2,i)
        u2 = ar(2,i+1)
        k1 = ar(3,i)
        k2 = ar(3,i+1)
        e1 = ar(4,i)
        e2 = ar(4,i+1)

        if ( y .ge. y1 .and. y .le. y2 ) then

          a1 = (u1 - u2)/(y1 - y2)
          b1 = (u2*y1 - u1*y2)/(y1 - y2)
          u  = a1*y + b1

          a2 = (k1 - k2)/(y1 - y2)
          b2 = (k2*y1 - k1*y2)/(y1 - y2)
          k  = a2*y + b2

          a3 = (e1 - e2)/(y1 - y2)
          b3 = (e2*y1 - e1*y2)/(y1 - y2)
          eps= a3*y + b3

          ready = .true.

        end if

        i = i + 1

      end do

      if ( ichoice .eq. 1 ) then
        usfunb = -u
      else if ( ichoice .eq. 2 ) then
        usfunb =  k
      else if ( ichoice .eq. 3 ) then
        usfunb =  eps 
      end if

      end
