      program cone
      implicit none

      integer nbuffr
      parameter( nbuffr = 5000000 )
      integer ibuffr
      common ibuffr(nbuffr)

      call ismain( nbuffr )

      end

      function usfunb ( ichoice, x, y, z, t )

c     User written function subroutine. It gives
c     the user the opportunity to define a
c     boundary condition as a function of space
c     and time.

      implicit none      

      double precision usfunb, x, y, z, t
      integer ichoice

c     x        i    x-coordinate 
c     y        i    y-coordinate 
c     t        i    actual time 
c     ichoice  i    choice parameter given by the user input
c     usfunb   o    computed boundary condition

      double precision omega, a, b, power

      omega = 2d0*3.1415926535d0

      if ( ichoice .eq. 1 ) then
        a = -1
        b = y        
      else if ( ichoice .eq. 2 ) then
        a = 1
        b = y
      else if ( ichoice .eq. 3 ) then
        a = x
        b = -1
      else if ( ichoice .eq. 4 ) then
        a = x
        b = 1 
      end if

      power = (a+5d-1*cos(omega*t))**2 + (b+5d-1*sin(omega*t))**2
      usfunb = 1d-2**(4*power)

      end

      function usfuni ( ichoice, x, y, z )

c     User written function subroutine. It gives
c     the user the opportunity to define an
c     initial value  as a function of space.

      implicit none      

      double precision usfuni, x, y, z
      integer ichoice

c     x        i    x-coordinate 
c     y        i    y-coordinate 
c     z        i    z-coordinate 
c     ichoice  i    choice parameter given by the userinput
c     usfuni   o    computed boundary condition

      double precision omega, power

      omega = 2d0*3.1415926535d0
      power = (x+5d-1)**2 + y**2

      if ( ichoice.eq.1 ) then
        usfuni = -omega*y
      else if ( ichoice.eq.2 ) then
        usfuni = omega*x
      else if ( ichoice.eq.3 ) then
        usfuni = 1d-2**(4*power)
      end if

      end




