      program dune
c=======================================================================
c
c     programmer      Kees Kassels
c
c     version  1.0    date    25-03-94
c
c   copyright (c) 1994  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c***********************************************************************
c
c              DESCRIPTION
c
c     ISNaS Host Program
c
c***********************************************************************
c
c             KEYWORDS
c
c     host_program
c
c***********************************************************************
c
c             INPUT / OUTPUT PARAMETERS
c
      implicit none
c***********************************************************************
c
c             COMMON BLOCKS
c
      integer nbuffr
      parameter( nbuffr = 8000000 )
      integer ibuffr
      common ibuffr(nbuffr)
c
c     IBUFFR    Integer buffer array in which all array information
c            with respect to the ISNaS software is stored.
c
c     NBUFFR    Declared length of IBUFFR
c
c
c***********************************************************************
c
c             LOCAL PARAMETERS
c
c
c***********************************************************************
c
c             SUBROUTINES CALLED
c
c     ISHMAIN    ISNaS host main subroutine
c
c***********************************************************************
c
c             I/O
c
c***********************************************************************
c
c             ERROR MESSAGES
c
c***********************************************************************
c
c             PSEUDO CODE
c
c       initialize local buffer
c       call ISNaS host main subroutine
c
c=======================================================================

      call ismain( nbuffr )

      end
      function usfunb ( ichoice, x, y, z, t )

c     User written function subroutine. It gives
c     the user the opportunity to define a
c     boundary condition as a function of space
c     and time.

      implicit none      

      double precision usfunb, x, y, z, t
      integer ichoice

c     x        i    x-coordinate 
c     y        i    y-coordinate 
c     t        i    actual time 
c     ichoice  i    choice parameter given by the user input
c     usfunb   o    computed boundary condition

      logical ready
      integer i
      double precision ar(1:4,1:41), y1, y2, u11, u12, u21, u22,
     +              k1, k2, 
     +              a1, b1, a2, b2, a3, b3, u1, u2, k ,eps, lscale,
     +              kappa, H, cmu, omega

      H = 0.319
      kappa = 0.41
      cmu = 0.09
      k = 0
      u1 = 0
      u2 = 0

      ar(1,1) = -1.900000000000000e-02
      ar(1,2) = -1.796100000000000e-02
      ar(1,3) = -1.683221461733921e-02
      ar(1,4) = -1.560588503109409e-02
      ar(1,5) = -1.427358194035497e-02
      ar(1,6) = -1.282614762457044e-02
      ar(1,7) = -1.125363299702550e-02
      ar(1,8) = -9.545229218783901e-03
      ar(1,9) = -7.689193403036464e-03
      ar(1,10) = -5.672767899176395e-03
      ar(1,11) = -3.482092601792686e-03
      ar(1,12) = -1.102109681828469e-03
      ar(1,13) =  1.483539914935692e-03
      ar(1,14) =  4.292628913501777e-03
      ar(1,15) =  7.344465872283920e-03
      ar(1,16) =  1.066002790244490e-02
      ar(1,17) =  1.426210485619934e-02
      ar(1,18) =  1.817545597517655e-02
      ar(1,19) =  2.242698007558152e-02
      ar(1,20) =  2.704590043993878e-02
      ar(1,21) =  3.206396568629177e-02
      ar(1,22) =  3.751566799555202e-02
      ar(1,23) =  4.343848019700636e-02
      ar(1,24) =  4.987311334161335e-02
      ar(1,25) =  5.686379653354505e-02
      ar(1,26) =  6.445858094342474e-02
      ar(1,27) =  7.270967009292646e-02
      ar(1,28) =  8.167377868098097e-02
      ar(1,29) =  9.141252241801660e-02
      ar(1,30) =  1.019928415478002e-01
      ar(1,31) =  1.134874609679986e-01
      ar(1,32) =  1.259753901121458e-01
      ar(1,33) =  1.395424660290052e-01
      ar(1,34) =  1.542819433922394e-01
      ar(1,35) =  1.702951354958759e-01
      ar(1,36) =  1.876921106415200e-01
      ar(1,37) =  2.065924487039995e-01
      ar(1,38) =  2.271260630757745e-01
      ar(1,39) =  2.494340936398296e-01
      ar(1,40) =  2.736698769089881e-01
      ar(1,41) =  3.000000000000000e-01

      ar(2,1) = .31360e+00
      ar(2,2) = .34216e+00
      ar(2,3) = .35224e+00
      ar(2,4) = .36400e+00
      ar(2,5) = .36777e+00
      ar(2,6) = .37187e+00
      ar(2,7) = .37631e+00
      ar(2,8) = .38115e+00
      ar(2,9) = .38640e+00
      ar(2,10) = .39102e+00
      ar(2,11) = .39604e+00
      ar(2,12) = .40149e+00
      ar(2,13) = .40741e+00
      ar(2,14) = .41384e+00
      ar(2,15) = .41488e+00
      ar(2,16) = .41600e+00
      ar(2,17) = .41723e+00
      ar(2,18) = .41856e+00
      ar(2,19) = .42000e+00
      ar(2,20) = .42537e+00
      ar(2,21) = .43120e+00
      ar(2,22) = .44194e+00
      ar(2,23) = .45360e+00
      ar(2,24) = .45865e+00
      ar(2,25) = .46413e+00
      ar(2,26) = .47009e+00
      ar(2,27) = .47656e+00
      ar(2,28) = .48325e+00
      ar(2,29) = .49051e+00
      ar(2,30) = .49840e+00
      ar(2,31) = .51016e+00
      ar(2,32) = .51794e+00
      ar(2,33) = .52640e+00
      ar(2,34) = .52640e+00
      ar(2,35) = .52640e+00
      ar(2,36) = .52640e+00
      ar(2,37) = .52640e+00
      ar(2,38) = .52640e+00
      ar(2,39) = .52640e+00
      ar(2,40) = .52640e+00
      ar(2,41) = .52640e+00

      ar(3,1) = .25200e-01
      ar(3,2) = .26813e-01
      ar(3,3) = .28560e-01
      ar(3,4) = .30983e-01
      ar(3,5) = .33600e-01
      ar(3,6) = .34341e-01
      ar(3,7) = .35143e-01
      ar(3,8) = .36014e-01
      ar(3,9) = .36960e-01
      ar(3,10) = .36222e-01
      ar(3,11) = .35419e-01
      ar(3,12) = .34544e-01
      ar(3,13) = .33600e-01
      ar(3,14) = .33046e-01
      ar(3,15) = .32444e-01
      ar(3,16) = .31791e-01
      ar(3,17) = .31080e-01
      ar(3,18) = .30308e-01
      ar(3,19) = .29471e-01
      ar(3,20) = .28560e-01
      ar(3,21) = .27530e-01
      ar(3,22) = .26414e-01
      ar(3,23) = .25200e-01
      ar(3,24) = .24522e-01
      ar(3,25) = .23787e-01
      ar(3,26) = .22985e-01
      ar(3,27) = .22114e-01
      ar(3,28) = .21168e-01
      ar(3,29) = .19189e-01
      ar(3,30) = .17020e-01
      ar(3,31) = .14672e-01
      ar(3,32) = .13007e-01
      ar(3,33) = .11200e-01
      ar(3,34) = .10662e-01
      ar(3,35) = .10080e-01
      ar(3,36) = .87282e-02
      ar(3,37) = .72610e-02
      ar(3,38) = .56627e-02
      ar(3,39) = .39278e-02
      ar(3,40) = .20474e-02
      ar(3,41) = .00000e+00

      ar(4,1) =  .25234e-02
      ar(4,2) =  .26473e-02
      ar(4,3) =  .27802e-02
      ar(4,4) =  .29263e-02
      ar(4,5) =  .30841e-02
      ar(4,6) =  .34679e-02
      ar(4,7) =  .38826e-02
      ar(4,8) =  .43335e-02
      ar(4,9) =  .48224e-02
      ar(4,10) =  .49211e-02
      ar(4,11) =  .50282e-02
      ar(4,12) =  .51449e-02
      ar(4,13) =  .52710e-02
      ar(4,14) =  .53742e-02
      ar(4,15) =  .54861e-02
      ar(4,16) =  .56075e-02
      ar(4,17) =  .57362e-02
      ar(4,18) =  .58761e-02
      ar(4,19) =  .60280e-02
      ar(4,20) =  .62296e-02
      ar(4,21) =  .64486e-02
      ar(4,22) =  .64486e-02
      ar(4,23) =  .64486e-02
      ar(4,24) =  .64486e-02
      ar(4,25) =  .60185e-02
      ar(4,26) =  .55514e-02
      ar(4,27) =  .54171e-02
      ar(4,28) =  .52710e-02
      ar(4,29) =  .50291e-02
      ar(4,30) =  .47664e-02
      ar(4,31) =  .40915e-02
      ar(4,32) =  .33645e-02
      ar(4,33) =  .28949e-02
      ar(4,34) =  .23832e-02
      ar(4,35) =  .21028e-02
      ar(4,36) =  .21028e-02
      ar(4,37) =  .21028e-02
      ar(4,38) =  .21028e-02
      ar(4,39) =  .21028e-02
      ar(4,40) =  .21028e-02
      ar(4,41) =  .21028e-02

      ready = .false.
      i = 1
      do while ( .not. ready .and. i .le. 40)

        y1  = ar(1,i)
        y2  = ar(1,i+1)
        u11 = ar(2,i)
        u12 = ar(2,i+1)
        u21 = ar(3,i)
        u22 = ar(3,i+1)
        k1  = ar(4,i)
        k2  = ar(4,i+1)
        if ( y .ge. y1 .and. y .le. y2 ) then

          a1 = (u11 - u12)/(y1 - y2)
          b1 = (u12*y1 - u11*y2)/(y1 - y2)
          u1 = a1*y + b1

          a2 = (u21 - u22)/(y1 - y2)
          b2 = (u22*y1 - u21*y2)/(y1 - y2)
          u2 = a2*y + b2

          a3 = (k1 - k2)/(y1 - y2)
          b3 = (k2*y1 - k1*y2)/(y1 - y2)
          k  = a3*y + b3

          ready = .true.

        end if

        i = i + 1

      end do

      lscale = min(kappa*(y+0.019), 0.1*H)

      if ( lscale .eq. 0d0 ) then
        eps = 1d4
      else
        eps = (cmu**75d-2)*(k**15d-1)/lscale
      end if

      if ( lscale .eq. 0d0 ) then
        omega = 1d4
      else
        omega = sqrt(k)/lscale
      end if

      if ( ichoice .eq. 1 ) then
        usfunb = -u1
      else if ( ichoice .eq. 2 ) then
        usfunb = -u2
      else if ( ichoice .eq. 3 ) then
        usfunb =  k
      else if ( ichoice .eq. 4 ) then
        usfunb =  eps 
      else if ( ichoice .eq. 5 ) then
        usfunb =  omega
      end if

      end
