      subroutine iscof1 ( coefs, ncoefs, npoint, cvalue, icoef)
c=======================================================================
c
c     programmer  Kees Kassels
c     version     1.0  date        10-02-89
c
c   copyright (c) 1994  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c***********************************************************************
c
c                   DESCRIPTION
c
c     Subroutine to fill the coefficients for the momentum equations
c     and/or transport equations into array coef with a constant value
c
c***********************************************************************
c
c                   INPUT / OUTPUT PARAMETERS
c
      implicit none
c
      integer ncoefs, npoint, icoef
      double precision coefs(1:npoint,1:ncoefs), cvalue
c
c     coefs         reserved
c     cvalue        Value with which coefs must be filled
c     icoef         Sequence number of coefficient
c     ncoefs        Number of coefficients
c     npoint        Number of points for one block
c
c***********************************************************************
c
c                   COMMON BLOCKS
c
c
c***********************************************************************
c
c                   LOCAL PARAMETERS
c
      integer i
c
c     i             General loop variable
c
c**********************************************************************
c
c                   I/O
c
c**********************************************************************
c
c                   SUBROUTINES CALLED
c
c     ISERCLOS    removes name of subroutine from error list
c     ISEROPEN    adds name of subroutine to error list
c
c**********************************************************************
c
c                   ERROR MESSAGES
c
c
c***********************************************************************
c
c     PSEUDO CODE    :
c
c     For i=1(1)NPOINT do
c
c        Fill COEFS  with constant VALUE
c
c        COEFS(I,ICOEF) = VALUE
c
c=======================================================================

      call iseropen('iscof1')

c     --- for npoint do

      do 10 i=1, npoint

         coefs(i,icoef) = cvalue

10    continue

      call iserclos('iscof1')

      end
