      subroutine iscof3( ichois, ni    , nj  , nk   , nvirtual,
     +                   ncoefs, rintur, eddy, coefs           )
c=======================================================================
c
c
c        programmer     Marcel Zijlema
c
c        version 1.0    date   29-11-94
c
c
c
c   copyright (c) 1994  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c***********************************************************************
c
c                      DESCRIPTION
c
c     Add eddy viscosity to molecular viscosity or to molecular
c     diffusivity coefficient w.r.t. a transport equation (3D)
c
c***********************************************************************
c
c                      KEYWORDS
c
c     turbulence
c
c***********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none

      integer ichois, ni, nj, nk, nvirtual, ncoefs

      double precision rintur(*),
     +                 eddy(1-nvirtual:ni+1+nvirtual,
     +                      1-nvirtual:nj+1+nvirtual,
     +                      1-nvirtual:nk+1+nvirtual),
     +                 coefs(1-nvirtual:ni+1+nvirtual,
     +                       1-nvirtual:nj+1+nvirtual,
     +                       1-nvirtual:nk+1+nvirtual,1:ncoefs)
c
c     coefs    o   reserved
c     eddy     i   reserved
c     ichois   i   General choice parameter
c     ncoefs   i   Number of coefficients
c     ni       i   Number of non-virtual cells in the i-direction (one block)
c     nj       i   Number of non-virtual cells in the j-direction (one block)
c     nk       i   Number of non-virtual cells in the k-direction (one block)
c     nvirtual i   Number of rows of virtual cells
c     rintur   i   reserved
c
c***********************************************************************
c
c                      COMMON BLOCKS
c
c***********************************************************************
c
c                      LOCAL PARAMETERS
c
      integer ip, jp, kp
c
c     ip        Local counting variable i-direction
c     jp        Local counting variable j-direction
c     kp        Local counting variable k-direction
c
c***********************************************************************
c
c                      SUBROUTINES CALLED
c
c***********************************************************************
c
c                      I/O
c
c***********************************************************************
c
c                      ERROR MESSAGES
c
c***********************************************************************
c
c                      PSEUDO CODE
c
c=======================================================================
c

      if ( ichois .eq. 1 ) then

        do 10 kp = 1, nk
          do 10 jp = 1, nj
            do 10 ip = 1, ni
              coefs(ip,jp,kp,2) = coefs(ip,jp,kp,2) +
     +                            coefs(ip,jp,kp,1) * eddy(ip,jp,kp)
10      continue

      else if ( ichois .gt. 1 ) then

        do 20 kp = 1, nk
          do 20 jp = 1, nj
            do 20 ip = 1, ni
              coefs(ip,jp,kp,4) = coefs(ip,jp,kp,4) +
     +                            coefs(ip,jp,kp,1) * eddy(ip,jp,kp) /
     +                            rintur(9)
              coefs(ip,jp,kp,6) = coefs(ip,jp,kp,6) +
     +                            coefs(ip,jp,kp,1) * eddy(ip,jp,kp) /
     +                            rintur(9)
              coefs(ip,jp,kp,9) = coefs(ip,jp,kp,9) +
     +                            coefs(ip,jp,kp,1) * eddy(ip,jp,kp) /
     +                            rintur(9)
20      continue

      end if

      end
