      subroutine isndt01 ( nblocks, isiinput, isrinput, iadmin, time,
     +                     dt, theta, itimeact )
c=======================================================================
c
c     programmer   Kees Kassels
c     version      2.0   date    22-02-95 Guus: extra parameter itime
c     version      1.2   date    12-12-94 M. Kooper theta in array rinput
c     version      1.1   date    17-10-94
c     version      1.0   date    17-05-94
c
c   copyright (c) 1994-1995  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c***********************************************************************
c
c                  DESCRIPTION
c
c     put parameter time in the array  rinput, and
c     put parameter dt   in the array  rinput, because
c     dt = theta * dt for the theta method
c     put parameter theta in the array rinput, because
c     theta changes in fractional theta method
c
c***********************************************************************
c
c                  KEYWORDS
c
c     time
c
c***********************************************************************
c
c                   INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer isiinput(*), isrinput(*), iadmin(*), itimeact
      integer  nblocks
      double precision time, dt, theta

c     dt        i    Time step
c     iadmin    i    reserved
c     isiinput  i    Array of sequence numbers (nblocks) of array iinput
c     isrinput  i    Array of sequence numbers (nblocks) of array rinput
c     itimeact  i    Actual time step
c     nblocks   i    Number of blocks
c     theta     i    Parameter theta for theta method
c     time      i    Actual time of time step
c***********************************************************************
c
c                   COMMON BLOCKS
c
      include 'IScommon/cisblank'
      include 'IScommon/cisparal'
c***********************************************************************
c
c                   LOCAL PARAMETERS
c
      integer iblock, ipiinput, iprinput, iprintim, ipiintim

c     iblock    Block sequence number
c     ipiinput  Starting address of array iinput in ibuffr
c     ipiintim  Starting address of array IINTIM in array IINPUT
c     iprinput  Starting address of array rinput in buffr
c     iprintim  Starting address of array RINTIM in array RINPUT
c**********************************************************************
c
c                   I/O
c
c**********************************************************************
c
c                   SUBROUTINES CALLED

      integer isdpgetp, isingetp
c
c     ISACTIVE      Activate old permanent array
c     ISDPGETP      get pointer double precision array
c     ISERCLOS      removes name of subroutine from error list
c     ISEROPEN      adds name of subroutine to error list
c     ISINGETP      get pointer integer array
c**********************************************************************
c
c                   ERROR MESSAGES
c
c***********************************************************************
c
c                   PSEUDO CODE
c
c     for iblock  := 1 (1) nblocks
c        if block at this node
c           put  t in the array  rinput
c
c=======================================================================

      call iseropen('isndt01')

      do 10 iblock = 1, nblocks

         if( iadmin(iblock) .eq. inodenr .or. iblock .eq. 1 ) then

            call isactive(isiinput(iblock))
            call isactive(isrinput(iblock))

            ipiinput = isingetp( isiinput(iblock) )
            iprinput = isdpgetp( isrinput(iblock) )

            ipiintim = ibuffr( ipiinput -1 + 4 )
            ibuffr ( ipiinput - 1 + ipiintim -1 + 4 )  = itimeact
            iprintim = ibuffr( ipiinput -1 + 29 )

            buffer( iprinput - 1 + iprintim -1 + 1 )  = time
            buffer( iprinput - 1 + iprintim -1 + 4 )  = dt
            buffer( iprinput - 1 + iprintim -1 + 5 )  = theta

         end if

10    continue


      call iserclos('isndt01')

      end
