      subroutine istemperature ( nblocks, isiinput, isrinput, issolut,
     +                           iseddy, iadmin )
c ======================================================================
c
c     programmer   Guus Segal
c     version      1.0   01-07-1999
c
c
c   copyright (c) 1999-1999  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   Compute the temperature from the internal energy
c
c **********************************************************************
c
c                       KEYWORDS
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer iadmin(*), iseddy(*), isiinput(*),
     +        isrinput(*), issolut(*), nblocks

c     iadmin         i    contains information about
c                         which blocks on which computer are stored.
c     iseddy         i    Array of sequence numbers (nblocks) of array eddy
c     isiinput       i    Array of sequence numbers (nblocks) of array iinput
c     isrinput       i    Array of sequence numbers (nblocks) of array rinput
c     issolut        i    Array of sequence numbers (nblocks) of array solut
c     nblocks        i    Number of blocks
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisblank'
      include 'IScommon/cisparal'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer iblock, ipiinput

c     iblock         Block sequence number
c     ipiinput       Starting address of array iinput in ibuffr
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
      integer  isingetp

c     ISACTIVE       Activate old permanent array
c     ISINGETP       get the pointer corresponding to an integer array
c     ISTEMPERAT01   Compute the temperature as function of the internal energy
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c
c     --- compute some general parameters

      call isactive(isiinput(1))
      call isactive(isrinput(1))

      ipiinput = isingetp(isiinput(1))
      nblocks  = ibuffr(ipiinput + 73 - 1)

      do iblock = 1, nblocks

         if ( iadmin(iblock).eq.inodenr .or. inodenr.eq.ISHOST ) then

            call istemperat01 ( isiinput(iblock), isrinput(iblock),
     +                          issolut(iblock), iseddy(iblock) )

          end if

      end do

      end
