      function isdlimt (rhotild)
c ======================================================================
c
c        programmer     Duncan van der Heul
c        version 1.2    date 12-12-1999  Duncan: back to isnas limiter
c        version 1.1    date 04-04-1999  Duncan: inclusion of general
c                                                 limited kappa scheme
c        version 1.0    date 15-07-1998
c
c   copyright (c) 1997-1997  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c  subroutine ISDLIMIT defines the limiter function for the density
c  bias in the pressure correction equation
c **********************************************************************
c
c                       KEYWORDS
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      double precision rhotild, isdlimt

c     isdlimt   Limiter function for density bias
c     rhotild   Dimensionless upwind variable rhotilde
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      if( abs(1+rhotild).gt.1d-12) then
         isdlimt=0.5d0*(rhotild+abs(rhotild))*
     +                (rhotild+3d0)/((1+rhotild)**2d0)
      else
         isdlimt=0.5d0*(rhotild+abs(rhotild))*
     +                (rhotild+3d0)*sign(1d-12,(1+rhotild)**2d0)
      end if
      end
