      subroutine ismakmpc2 ( alphad, locdx, pnttyp, dcell,
     +                       nintpol, dij )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date 24-02-1998
c
c   copyright (c) 1998-1998  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c **********************************************************************
c
c                       DESCRIPTION
c
c     Compute some quantities with respect to interpolation, position and so
c     on for one integration point and one direction. (2D)
c **********************************************************************
c
c                       KEYWORDS
c
c    matrix
c    right_hand_side
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer alphad, locdx(2,5), pnttyp(5), dcell(2,5),
     +        nintpol(2,5), dij(2,4,2,5)

c     alphad    i    Direction index of integration.
c                    Hence if a V1-cell is used, alphad = 1 and so on
c     dcell     o    reserved
c     dij       o    Array containing the distances of the interpolation
c                    points to the cell centra in global co-ordinates
c                    dij(alpha,i,j) denotes the distance of the i-th
c                    interpolation point, component j and with respect to
c                    the V-alpha unknown (distribution)
c     locdx     o    Position of the integration point with respect to
c                    the centre of the integration cell
c                    The cell sizes are assumed to be 2 times 2, hence the
c                    distance of a midside point to a cell centre is always 1
c     nintpol   o    Number of interpolation points in the distribution
c     pnttyp    o    reserved
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer intn

c     intn      Integration point number
c **********************************************************************
c
c                       I/O
c
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISMAKMP2  Make a list of integration points for the momentum equations
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c
      do intn = 1, 5
         call ismakmp2 ( intn, alphad, locdx(1,intn), pnttyp(intn),
     +                   dcell(1,intn), nintpol(1,intn),
     +                   dij(1,1,1,intn) )
      end do

      end
