      subroutine isfili03(ni, nj, nk, ndim, nvirtual, coloc, coor)
c=====================================================================
c
c        programmer   Erik Brakkee
c        version 1.0    date 23-05-94
c
c
c   copyright (c) 1994  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c***********************************************************************
c
c                  DESCRIPTION
c
c     Fill the inner regions of the local coor array (extended with
c     row of virtual unknowns) with values from the (normal) coor array
c     for a certain block (3-D only)
c
c***********************************************************************
c
c                  KEYWORDS
c
c   mapping_array
c   topology
c***********************************************************************
c
c                  INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ni, nj, nk, ndim, nvirtual

      double precision coloc(1:ni+1, 1:nj+1, 1:nk+1, 1:ndim)

      double precision coor(1-nvirtual:ni+1+nvirtual,
     +                      1-nvirtual:nj+1+nvirtual,
     +                      1-nvirtual:nk+1+nvirtual,
     +                      1:ndim)

c     coloc     i    coordinate array without virtual points
c     coor      o    local coordinate array
c     ndim      i    dimension of the problem
c     ni        i    i-dimension of the block
c     nj        i    j-dimension of the block
c     nk        i    k-dimension of the block
c     nvirtual  i    number of virtual rows in solut
c***********************************************************************
c
c                   COMMON BLOCKS
c
c***********************************************************************
c
c                   LOCAL PARAMETERS
c
      integer i, idim, j, k
c
c     i         Loop variable
c     idim      Loop variable
c     j         Loop variable
c     k         Loop variable
c
c**********************************************************************
c
c                   I/O
c
c      none
c
c**********************************************************************
c
c                   SUBROUTINES CALLED
c
c      None
c
c**********************************************************************
c
c                   ERROR MESSAGES :
c
c        -
c
c***********************************************************************
c
c     PSEUDO CODE    :
c
c
c=======================================================================
c


      do idim = 1, ndim
         do k = 1, nk+1
            do j = 1, nj+1
               do i = 1, ni+1

                  coor(i,j,k,idim) = coloc(i,j,k,idim)

               enddo
            enddo
         enddo
      enddo


      end
