      subroutine ismakadm ( nmachines, nblocks, iadmin )
c ======================================================================
c
c
c        programmer     Guus Segal
c        version 1.2    date 01-10-1998 Jason: make sure output only from host
c        version 1.1    date 29-11-1995 (Replace write(* by write(irefwr)
c        version 1.0    date 26-05-1994
c
c
c   copyright (c) 1994-1995  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                      DESCRIPTION
c
c    Ad-hoc subroutine to fill array iadmin
c    Should be replaced by a more clever subroutine in the future
c ********************************************************************
c
c                      KEYWORDS
c
c    administration
c    parallel
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer nblocks, iadmin(nblocks), nmachines

c     iadmin    i    reserved
c     nblocks   i    number of blocks
c     nmachines i    Number of nodes that are used
c ********************************************************************
c
c                      COMMON BLOCKS
c
      include 'IScommon/cisnas'
      include 'IScommon/cisparal'
c ********************************************************************
c
c                      LOCAL PARAMETERS
c
      integer iblock, ind, ndistr, nloc, nodenr
      
c
c     iblock    block number
c     ind       Node number 
c     ndistr    Number of blocks distributed across nodes for 
c               nodes with sequence numbers less than nodenr
c     nloc      Number of local blocks of node nodenr
c     nodenr    Next sequence number of node
c
c ********************************************************************
c
c                      SUBROUTINES CALLED
c
c ********************************************************************
c
c                      I/O
c
c ********************************************************************
c
c                      ERROR MESSAGES
c
c ********************************************************************
c
c                      PSEUDO CODE
c
c
c ======================================================================
c


      if ( nmachines.le.1 ) then

c     --- Only one computer

         do iblock = 1, nblocks
            iadmin(iblock) = 0
         end do

      else

c     --- More than one computer
         if ( inodenr .eq. ISHOST ) then 
            write(irefwr,*) ' '
            write(irefwr,*) 'DISTRIBUTION OF BLOCKS ACROSS NODES'
            write(irefwr,*) ' '
            write(irefwr,*) 'IBLOCK      INODE'
         end if 

         ndistr = 0
         nloc   = 0
         nodenr = 0
         
         do ind = 0, nmachines-1
         
            nloc = ( nblocks - ndistr) / (nmachines-ind)
            
            do iblock = ndistr+1, ndistr+nloc
            
               iadmin(iblock) = ind
         
               if ( inodenr .eq. ISHOST ) 
     +               write(irefwr,1010) iblock, iadmin(iblock)

            enddo
            
            ndistr = ndistr + nloc
         
         enddo

         if ( inodenr .eq. ISHOST ) write(irefwr,*) ' '

      end if
      
1010  format(I5, '      ', I4)      

      end
