      subroutine isposor1 ( usol, work, ni, nj )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date 25-06-1996
c
c
c   copyright (c) 1996-1996  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     Change directions in solution array
c
c **********************************************************************
c
c                       KEYWORDS
c
c   orientation
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ni, nj
      double precision usol(*), work(*)

c     ni        i    Number of non-virtual cells in the i-direction (one block)
c     nj        i    Number of non-virtual cells in the j-direction (one block)
c     usol     i/o   Solution vector of length n. On input the array should
c                    contain a starting vector. At output the array contains
c                    the last iterate, which is an approximation to the
c               solution of the system.
c     work           Work array
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisnas'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer i, j

c     i         General loop variable
c     j         General loop variable
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      do i = 1, ni+1
         do j = 1, nj+1
            work((i-1)*(nj+1)+j) = usol((j-1)*(ni+1)+i)
         end do
      end do
      do i = 1, (ni+1)*(nj+1)
         usol(i) = work(i)
      end do

      end
