      subroutine LUy ( mat, LUymat, nxa, nya, sl1, sl2, sl3, sl4)
c ======================================================================
c
c        programmer     Jos van Kan
c
c       version 1.1    10-04-1997
c         utilizes module mgpreset instead of common block cmgconst
c       version 1.0    27-03-1997
c
c
c   copyright (c) 1997
c   all rights reserved. no part of th(ix publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, d(ixk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherw(ixe, without written perm(ixsion from the
c   author.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c
c
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer sl1, sl2, sl3, sl4
      integer nxa, nya
      double precision
     +mat(1-sl1:nxa+sl2,1-sl3:nya+sl4,9),
     +LUymat(1-sl1:nxa+sl2,1-sl3:nya+sl4,3)

c     luymat    o    LU dec of "diagonal" blocks vert numbering
c     mat       i    The nx x ny x 9 coefficient matrix of the
c                    discrete Laplacian
c     nxa       i    Number of grid x points on this level
c     nya       i    Number of grid y points on this level
c     sl1       i    Slack variable, x lower bound
c     sl2       i    Slack variable, x upper bound
c     sl3       i    Slack variable, y lower bound
c     sl4       i    Slack variable, y upper bound
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ixa, iya

c     ixa       Counter to number of grid x points on this level
c     iya       Counter to number of grid y points on this level
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c  trivial
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      do ixa = 1, nxa
        LUymat (ixa, 1, DIAG) = mat (ixa, 1, p11)
        LUymat (ixa, 1, SUP) = mat (ixa, 1, p12)
        do iya = 2, nya
          LUyMat (ixa, iya, SUB) = mat (ixa, iya, p10)/ LUyMat
     +           (ixa, iya - 1, DIAG)
          LUymat (ixa, iya, DIAG) = mat (ixa, iya, p11) -
     +           LUymat (ixa, iya-1, SUP) * LUymat (ixa, iya, SUB)
          LUymat (ixa, iya, SUP) = mat (ixa, iya, p12)
        end do
      end do
      end
