      subroutine errmsg ( subrname, message, fatal, ibuf)
c ======================================================================
c
c        programmer     Jos van Kan
c
c       version 1.1    10-04-1997
c         utilizes module mgpreset instead of common block cmgconst
c       version 1.0    27-03-1997
c
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   Prints appropriate errormessages from the MG package and keeps
c   count. If an error is fatal or more than 10 non-fatal errors have
c   been encountered the subroutine mgexit is called to exit the
c   package.
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibuf(*)
      character*(*) subrname, message
      logical fatal

c     fatal     i    True if error is fatal.
c     ibuf      i    Integer array of dimension 300 that contains the
c                    administration of this particular multi grid block.
c     message   i    (Error) message (multi grid only)
c     subrname  i    Name of subroutine in which error handler is called
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     MGEXIT    Wrapper to exit MG in case of fatal error. (MG)
c               APPLICATION HAS TO PROVIDE THIS. Defaults to stop. (MG)
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      write (*,*) 'Error in MG subroutine ', subrname, ': ', message
      ibuf (errcnti) =  ibuf (errcnti) + 1
      if (fatal) then
      write (*,*) "Fatal error encountered in multi grid package, "
     +  ,"program halted"
      call mgexit
      end if

      if (ibuf (errcnti).gt.10) then
      write (*,*) "Program halted, at least 10 errors in multi grid "
      call mgexit
      end if
      end
