      subroutine mklvinf3 (ibuf)
c ======================================================================
c
c        programmer     Jos van Kan
c       version 1.2    date  8- 7-1997
c       version 1.1    10-04-1997
c        version 1.0    date Tue Apr  8 1997
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c **********************************************************************
c
c                       MODULES USED
c
      use mgpreset
c **********************************************************************
c
c                       DESCRIPTION
c
c   mklvlinf3 generates the sizes in different directions for all
c   levels and puts them in ibuf.
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ibuf (*)

c     ibuf      i    Integer array of dimension 300 that contains the
c                    administration of this particular multi grid block.
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
c     corri     Rbuf (ibuf (corri + ilevel)) is the first element
c               of the correction vector at level ilevel. (ilevel >=0)
c               (module mgpreset)
c     luxri     Rbuf (ibuf (LUxri + ilevel)) is the first element
c               of the LUx decomposition at level ilevel (ilevel >= 0)
c               (module mgpreset)
c     luyri     Rbuf (ibuf (LUyri + ilevel)) is the first element
c               of the LUy decomposition at level ilevel (ilevel >= 0)
c               (module mgpreset)
c     luzri     Rbuf (ibuf (LUzri + ilevel)) is the first element
c               of the LUz decomposition at level ilevel (ilevel >= 0)
c               (module mgpreset)
c     matri     Rbuf (ibuf (matri + ilevel)) is the first element
c               of the RAP operator at level ilevel (ilevel >= 1)
c               (module mgpreset)
c     resri     Rbuf (ibuf (resri + ilevel)) is the first element
c               of the res vector at level ilevel (ilevel >= 0) (module
c               mgpreset)
c     rhsri     Rbuf (ibuf (rhsri + ilevel)) is the first element
c               of the right hand side vector at level ilevel
c               (ilevel >= 1) (module mgpreset)
c     solri     Rbuf (ibuf (solri + ilevel)) is the first element
c               of the sol vector at level ilevel (ilevel >= 1) (module
c               mgpreset)
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     MKGEOM3   Fills arrays describing geometry (size, center)  (MG3)
c     MKMTVC3   Reserves space for matrix or vector on all levels  (MG3)
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call mkgeom3 (ibuf)
      call mkmtvc3 (matri, 1, 27, ibuf)
      call mkmtvc3 (rhsri, 1, 1, ibuf)
      call mkmtvc3 (solri, 1, 1, ibuf)
      call mkmtvc3 (LUxri, 0, 3, ibuf)
      call mkmtvc3 (LUyri, 0, 3, ibuf)
      call mkmtvc3 (LUzri, 0, 3, ibuf)
      call mkmtvc3 (resri, 0, 1, ibuf)
      call mkmtvc3 (corri, 0, 1, ibuf)
      end
