      subroutine triadv3  ( vec1, ww, vec2, res, nxa, nya, nza,
     +  sl1, sl2, sl3, sl4, sl5, sl6)
c ======================================================================
c
c        programmer     Jos van Kan
c       version 1.2    date  8- 7-1997
c       version 1.1    10-04-1997
c        version 1.0    date Tue Apr  8 1997
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c **********************************************************************
c
c                       MODULES USED
c
      use mgpreset
c **********************************************************************
c
c                       DESCRIPTION
c
c   adds ww*vec2 to vec1 and stores result in res.
c   vec1, vec2 and res are not necessarily different.
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer sl1, sl2, sl3, sl4, sl5, sl6
      integer nxa, nya, nza
      double precision ww
      double precision
     + vec1 (1-sl1:nxa+sl2, 1-sl3:nya+sl4,
     + 1-sl5:nza+sl6),
     + vec2 (1-sl1:nxa+sl2, 1-sl3:nya+sl4,
     + 1-sl5:nza+sl6),
     + res (1-sl1:nxa+sl2, 1-sl3:nya+sl4,
     + 1-sl5:nza+sl6)

c     nxa       i    Number of grid x points on this level
c     nya       i    Number of grid y points on this level
c     nza       i    Number of grid z points on this level
c     res       o    Residual (any level)
c     sl1       i    Slack variable, x lower bound
c     sl2       i    Slack variable, x upper bound
c     sl3       i    Slack variable, y lower bound
c     sl4       i    Slack variable, y upper bound
c     sl5       i    Slack variable, z lower bound
c     sl6       i    Slack variable, z upper bound
c     vec1      i    Generic name for quantity with the dimension of
c                    sol or rhs
c     vec2      i    Generic name for quantity with the dimension of
c                    sol or rhs
c     ww        i    Weight(s)
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ixa, iya, iza

c     ixa       Counter to number of grid x points on this level
c     iya       Counter to number of grid y points on this level
c     iza       Counter to number of grid z points on this level
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      do iza = 1, nza
      do iya = 1, nya
      do ixa = 1, nxa
       res (ixa,iya,iza) = vec1 (ixa,iya,iza) +  ww * vec2 (ixa,iya,iza)
      end do
      end do
      end do
      end
