      subroutine iscontrst (  work, lwork )
c ======================================================================
c
c
c        programmer     Kees Kassels
c        version 1.1    date 02-04-98 change maxnsess
c        version 1.0    date 28-04-95
c
c   copyright (c) 1994-1994  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c ********************************************************************
c
c                         DESCRIPTION
c
c    Print contents of the restart file
c
c ********************************************************************
c
c                      KEYWORDS
c
c     backing_storage
c     restart
c
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer lwork, work(lwork)


c     lwork      i    Length of array work
c     work       i/o  Work array

c ********************************************************************
c
c                    COMMON BLOCKS
c
      include 'IScommon/cisnas'
      include 'IScommon/cisnasch'
c
c ********************************************************************
c
c                    LOCAL PARAMETERS
      integer maxnsess
      parameter ( maxnsess = 100 )
      logical  notready
      integer  i, ios,  lsess, ifree2l,
     +        nsessions, sesname(maxnsess), sesrecord(maxnsess),
     +        isession, itimenext, irectime

      double precision   time


c     i           General loop variable
c     ifree2l     Local value for ifree2
c     ios         Iostatus variable
c     irectime    Record number of time record
c     isession    Session number
c     itimenext   Record number of next time record
c     lsess       Help variable for the length of arrays sesname and sesrecord
c     maxnsess    Maximum number of sessions
c     notready    Logical help variable
c     nsessions   Number of sessions
c     sesname     Array with session numbers of all sessions
c     sesrecord   Array with first record numbers of all sessions
c     time        Actual time of time step

c ********************************************************************
c
c             SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISERRINT  Put integer value in error message
c     ISERRSUB  Error messages
c
c ********************************************************************
c
c                              I/O
c
c ********************************************************************
c
c                    ERROR MESSAGES
c
c     20      Error in reading record
c
c ********************************************************************
c
c                    PSEUDO CODE
c
c
c ********************************************************************
c
c                    DATA STATEMENTS
c
c ======================================================================
c
c     --- read record 1

      lsess = maxnsess
      read(iref2, rec=1, iostat=ios ) nrec2, ifree2l,
     +     lsess, nsessions, (sesname(i),i=1,lsess),
     +     (sesrecord(i),i=1,lsess)

      if ( ios .ne. 0 ) then
c     --- error in reading record 1
         call iseropen ( 'isinirst' )
         call iserrint ( iref2, 1 )
         call iserrint ( ios, 2 )
         call iserrsub ( 20, 2, 0, 0 )
         call iserclos ( 'isinirst' )
         stop
      end if

      write(irefwr,10) nsessions
10    format( //' Number of sessions in RESTARTFILE = ', i4,/)

      do isession = 1, nsessions

         write(irefwr,20) isession, sesname(isession)
20       format( /' Number(name) of session :',i4,'    = ',i4)

c     --- read record isession

          read(iref2, rec=sesrecord(isession), iostat=ios )
     +               (work(i),i=1,lwork)
          if ( ios .ne. 0 ) then
c         --- error in reading record
             call iseropen ( 'iscontrst' )
             call iserrint ( iref2, 1 )
             call iserrint ( ios, 2 )
             call iserrsub ( 20, 2, 0, 0 )
             call iserclos ( 'iscontrst' )
             stop
          end if

          irectime = work(5)

c     --- read / write time records

          write(irefwr,30)
30        format( ' For the following times the solution is written',
     +            /' to the restart file for this session' )

          notready= .true.
200       if( notready ) then
             read(iref2, rec=irectime, iostat=ios ) time, itimenext
             if ( ios .ne. 0 ) then
c            --- error in reading record
                call iseropen ( 'iscontrst' )
                call iserrint ( iref2, 1 )
                call iserrint ( ios, 2 )
                call iserrsub ( 20, 2, 0, 0 )
                call iserclos ( 'iscontrst' )
                stop
             end if
             if ( itimenext .eq. -1 ) then
                notready = .false.
                write(irefwr,40) time
             else
                write(irefwr,40) time
40              format( 10x,d12.6)
                irectime = itimenext
             end if
             goto 200
          end if

      end do

      end
