      subroutine isprisol ( iequa, isiinput, issolut, text )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date   15-09-1999
c
c
c     copyright (c) 1999-1999  "Ingenieursbureau SEPRA"
c     permission to copy or distribute this software or documentation
c     in hard copy or soft copy granted only by written license
c     obtained from "Ingenieursbureau SEPRA".
c     all rights reserved. no part of this publication may be reproduced,
c     stored in a retrieval system ( e.g., in memory, disk, or core)
c     or be transmitted by any means, electronic, mechanical, photocopy,
c     recording, or otherwise, without written permission from the
c     publisher.
c **********************************************************************
c
c                       DESCRIPTION
c
c    Print the solution at the last time level for equation iequa
c    The string "text" is printed as heading
c **********************************************************************
c
c                       KEYWORDS
c
c    print
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer iequa, isiinput(*), issolut(*)
      character *(*) text

c     iequa          i    General equation sequence number
c     isiinput       i    Array of sequence numbers (nblocks) of array iinput
c     issolut        i    Array of sequence numbers (nblocks) of array solut
c     text           i    String in which a text is stored
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisblank'
      include 'IScommon/cisnas'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer iblock, ipsolut, ipiinput, nblocks

c     iblock         Block sequence number
c     ipiinput       Starting address of array iinput in ibuffr
c     ipsolut        Starting address of array solut in buffer
c     nblocks        Number of blocks
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
      integer isdpgetp, isingetp

c     ISACTIVE       Activate old permanent array
c     ISDPGETP       get the pointer corresponding to a double precision array
c     ISINGETP       get the pointer corresponding to an integer array
c     ISLSOLPR       print the solution just after the computation by the linear
c                    solver
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================

      write(irefwr,*) text
      ipiinput = isingetp(isiinput(1))
      nblocks  = ibuffr(ipiinput + 73 - 1)
      do iblock = 1, nblocks
         iblockrf = iblock
         call isactive(isiinput(iblock))
         call isactive(issolut(iblock))
         ipiinput = isingetp(isiinput(iblock))
         ipsolut  = isdpgetp(issolut(iblock) )
         call islsolpr ( iequa, ibuffr(ipiinput), buffer(ipsolut) )
      end do
      end
