      subroutine isrcspec 
c ======================================================================
c
c        Programmer     Jason Frank
c
c     copyright (c) 1994-1996  "TU-Delft"
c     Permission to copy or distribute this software or documentation
c     in hard copy or soft copy granted only by written license
c     obtained from "TU-Delft"
c     All rights reserved. No part of this publication may be
c     reproduced, stored in a retrieval system (e.g., in memory, disk,
c     or core) or be transmitted by any means, electronic, mechanical,
c     photocopy, recording, or otherwise, without written Permission
c     from the publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     Handle any pending special messages
c **********************************************************************
c
c                       KEYWORDS
c
c     parallel
c     receive
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none

c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisparal'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      logical isprobe, done
      external isprobe

c     done     loop control variable
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISPROBE   Checks if a pending message has a particular context
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call iseropen ( 'isrcspec' )

      done = .false.

      do while ( .not. done)

	 done = .true.

         if ( isprobe ( ICPRINT ) ) then

c        --- there is a Print message  

	    call isprrecv
	    done = .false.

         else if ( isprobe ( ICWARN ) ) then 

c        --- there is a Warning

	    call iserrecv ( ICWARN )
	    done = .false.

	 else if ( isprobe ( ICERROR ) ) then

c        --- there is an Error

	    call iserrecv ( ICERROR )
	    done = .false.

	 end if

      end do

      call iserclos ( 'isrcspec' )
      end
