      function isfincur ( icurvinf, iblock, ipstart, ncurvs )
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.0    date   18-03-1996
c
c   copyright (c) 1996-1996  "TU-Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU-Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                  DESCRIPTION
c
c     Find curve number corresponding to block number and starting
c     address in iinbc
c **********************************************************************
c
c                  KEYWORDS
c
c     boundary_conditions
c     error_manipulation
c **********************************************************************
c
c                   INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer ncurvs, icurvinf(4,ncurvs), iblock, ipstart, isfincur

c     iblock    i    Block sequence number
c     icurvinf  i    reserved
c     ipstart   i    Starting address
c     isfincur  o    Curve number
c     ncurvs    i    Number of curves (SEPRAN environment)
c **********************************************************************
c
c                   COMMON BLOCKS
c
c **********************************************************************
c
c                   LOCAL PARAMETERS
c
      integer j
      logical notfound

c     j         General loop variable
c     notfound  Logical help variable
c **********************************************************************
c
c                   I/O
c
c **********************************************************************
c
c                   SUBROUTINES CALLED
c
c **********************************************************************
c
c                   ERROR MESSAGES
c
c **********************************************************************
c
c                   PSEUDO CODE
c
c     notfound := true
c     j := 1
c     while ( notfound ) do
c        if ( icurvinf(1,j)=iblock and icurvinf(2,j)=ipstart ) then
c           isfincur = j
c           notfound := false
c        j := j+1
c        if ( j=ncurvs+1 ) then
c           isfincur = 0
c           notfound := false
c ======================================================================
c
      notfound = .true.
      j = 1
100   if ( notfound ) then
         if ( icurvinf(1,j).eq.iblock ) then
            if ( icurvinf(2,j).eq.ipstart ) then
               isfincur = j
               notfound = .false.
            end if
         end if
         j = j+1
         if ( j.ge.ncurvs+1 ) then
            isfincur = 0
            notfound = .false.
         end if
         go to 100
      end if

      end
