      subroutine iswrmpi ( nmachines, machin )
c ======================================================================
c
c        programmer     Guus Segal
c        version 2.0    date 27-05-1999 Guus: extra parameter
c        version 1.0    date 04-12-1998
c
c   copyright (c) 1998-1999  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c    Create a file isnas.mpi.script in which the script to be executed is
c    written
c **********************************************************************
c
c                       KEYWORDS
c
c    write
c    script
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer nmachines, machin

c     machin    i    Type of computer system. Possible values:
c                     1    IBM
c                     2    Cyber   (NOS/VE)
c                     3    Apollo  (Unis/Aegis)
c                     4    HP 9000 (HP/UX)
c                     5    .....    Unix
c                     6    VAX      VMS
c                     7    Harris
c                     8    Cray
c                     9    IBM PC 386   MSDOS + FTN77/386
c                    10    CONVEX
c                    13    Alliant
c     nmachines i    Number of nodes that are used
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      logical check

c     check     Indication if a file has been opened (true) or not (false)
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      open ( unit=33, file = 'isnas.mpi.script' )
      if ( nmachines.le.1 ) then

c     --- Serial case, only one computer

         write(33,100)
100      format('isnasexe ')
         inquire ( file = 'isnasmpi_testfile', exist = check )
         if ( check ) then
            open ( unit = 93, file = 'isnasmpi_testfile' )
            close ( unit  = 93, status = 'delete' )
         end if

      else if ( machin.eq.8 ) then

c     --- Parallel case using the Cray

         write(33,110) nmachines
110      format('mpirun -np ',i3,' isnasexe')
      else

c     --- Parallel case other computers

         write(33,110) nmachines

      end if
      close ( 33 )
      end
