      subroutine iswrtif0 ( icommon, dcommon, idimens, ichoice, irefsv )
c ======================================================================
c
c        programmer     Guus Segal
c        version 2.9    date 20-04-1999 Guus: raise version number to 17
c        version 2.8    date 18-03-1999 Guus: include choice(6)
c        version 2.7    date 08-09-1997 Guus: include choice(5)
c        version 2.6    date 04-09-1997 Guus: include choice(4)
c        version 2.5    date 02-09-1997 Guus: include choice(3)
c        version 2.4    date 10-07-1997 Guus: include icommon/choice(2)
c        version 2.3    date 17-02-1997 Marcel: raise version number to 14
c        version 2.2    date 11-02-1997 Kees: raise version number to 13
c        version 2.1    date 10-09-1996 Marcel: raise version number to 12
c        version 2.0    date 23-08-1996 Marcel: raise version number to 11
c        version 1.9    date 22-05-1996 Marcel: raise version number to 10
c        version 1.8    date 25-04-1996 Kees: raise version number to 9
c        version 1.7    date 17-04-1996 Kees: raise version number to 8
c        version 1.6    date 18-10-1995 Marcel: raise version number to 7
c        version 1.5    date 09-05-1995 Kees: raise version number to 6
c        version 1.4    date 07-02-1995 Guus: raise version number to 5
c        version 1.3    date 07-02-1995 Guus: raise version number to 4
c        version 1.2    date 12-01-1995 Guus: raise version number to 3
c        version 1.1    date 14-11-1994 Kees K version nr. interm. file
c                                       is now 2
c        version 1.0    date 27-09-1994
c
c
c   copyright (c) 1994-1999  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c    Open and write first part of the intermediate file
c    It concerns the blocks 1 to 4
c **********************************************************************
c
c                       KEYWORDS
c
c    intermediate_file
c    write
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer icommon(100), idimens(100), ichoice(100), irefsv
      double precision dcommon(100)

c     dcommon   i    Contains all real values in the common block CISNAS
c     ichoice   i    Integer choice parameters for the intermediate file
c     icommon   i    Contains all integer values in the common block CISNAS
c     idimens   i    Integer dimension parameters for the intermediate file
c     irefsv    o    Help variable to save the value of a reference number
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisnas'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer i, iversion

c     i         General loop variable
c     iversion  Version sequence number
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISINIFIL  Open files
c **********************************************************************
c
c                       I/O
c
c     This subroutine opens the intermediate file and writes the following parts
c     Block 1: version number
c     Block 2: global parameters
c     Block 3: dimension parameters
c     Block 4: choice parameters
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c    Open intermediate file
c    Write version number
c    Write global parameters
c    Write dimension parameters
c    Write choice parameters
c **********************************************************************
c
c                       DATA STATEMENTS
c
c **********************************************************************
c
c                       MODULES USED
c
c ======================================================================
c
      call iseropen ( 'iswrtif0' )

c     --- Open intermediate file

      call isinifil(75)
      irefsv = irefwr
      irefwr = iref75

c     --- Write version number

      iversion = 17
      write(irefwr,100) iversion
100   format ( /'* Intermediate file for the ISNaS incompressible',
     +          ' Navier-Stokes equations'//
     +          '**** BLOCK 1: version number'//
     +          'version', i3 /)

c     --- Write global parameters

      write(irefwr,200) (icommon(i),i=1,100)
200   format ( /'**** BLOCK 2: Global parameters for the common',
     +          ' block CISNAS'//
     +          '* 100 integers:'//
     +          'IOUTPT = ',i5/ 'ITIME  = ',i5/
     +          8i2,7x,' # Positions  3-10 not yet defined'/
     +          10i2,3x,' # Positions 11-20 not yet defined'/
     +          10i2,3x,' # Positions 21-30 not yet defined'/
     +          10i2,3x,' # Positions 31-40 not yet defined'/
     +          10i2,3x,' # Positions 41-50 not yet defined'/
     +          10i2,3x,' # Positions 51-60 not yet defined'/
     +          10i2,3x,' # Positions 61-70 not yet defined'/
     +          10i2,3x,' # Positions 71-80 not yet defined'/
     +          10i2,3x,' # Positions 81-90 not yet defined'/
     +          10i2,3x,' # Positions 91-100 not yet defined'// )

      write(irefwr,210) (dcommon(i),i=1,100)
210   format ( / '* 100 reals:'//
     +          10f4.0,3x,' # Positions  1-10 not yet defined'/
     +          10f4.0,3x,' # Positions 11-20 not yet defined'/
     +          10f4.0,3x,' # Positions 21-30 not yet defined'/
     +          10f4.0,3x,' # Positions 31-40 not yet defined'/
     +          10f4.0,3x,' # Positions 41-50 not yet defined'/
     +          10f4.0,3x,' # Positions 51-60 not yet defined'/
     +          10f4.0,3x,' # Positions 61-70 not yet defined'/
     +          10f4.0,3x,' # Positions 71-80 not yet defined'/
     +          10f4.0,3x,' # Positions 81-90 not yet defined'/
     +          10f4.0,3x,' # Positions 91-100 not yet defined'// )

c     --- Write dimension parameters

      write(irefwr,300) (idimens(i),i=1,100)
300   format ( /'**** BLOCK 3: Dimension parameters '//
     +          '* 100 integers:'//
     +          'NVIRTUAL  = ',i5/ 'NDEGFD    = ',i5/
     +          'NTRNSP    = ',i5/ 'NTIMLV    = ',i5/
     +          'NCOEFS    = ',i5/ 'NTURB     = ',i5/
     +          'NMACHINES = ',i5/ 'NCLUSTERS = ',i5/
     +          'LENICLUSTER = ',i5/
     +            i2,17x,' # Position    10 not yet defined'/
     +          10i2,3x,' # Positions 11-20 not yet defined'/
     +          10i2,3x,' # Positions 21-30 not yet defined'/
     +          10i2,3x,' # Positions 31-40 not yet defined'/
     +          10i2,3x,' # Positions 41-50 not yet defined'/
     +          10i2,3x,' # Positions 51-60 not yet defined'/
     +          10i2,3x,' # Positions 61-70 not yet defined'/
     +          10i2,3x,' # Positions 71-80 not yet defined'/
     +          10i2,3x,' # Positions 81-90 not yet defined'/
     +          10i2,3x,' # Positions 91-100 not yet defined'// )

c     --- Write choice parameters

      write(irefwr,400) (ichoice(i),i=1,100)
400   format ( /'**** BLOCK 4: Choice parameters '//
     +          '* 100 integers:'//
     +          'IGEO     = ',i5/
     +          'POSTTYPE = ',i5/
     +          'MSHTYPE  = ',i5/
     +          'COUPLED/DECOUPLED  = ',i5/
     +          'MCAV     = ',i5/
     +          'IGEOTIME = ',i5/
     +          4i2,5x, ' # Positions  6-10 not yet defined'/
     +          10i2,3x,' # Positions 11-20 not yet defined'/
     +          10i2,3x,' # Positions 21-30 not yet defined'/
     +          10i2,3x,' # Positions 31-40 not yet defined'/
     +          10i2,3x,' # Positions 41-50 not yet defined'/
     +          10i2,3x,' # Positions 51-60 not yet defined'/
     +          10i2,3x,' # Positions 61-70 not yet defined'/
     +          10i2,3x,' # Positions 71-80 not yet defined'/
     +          10i2,3x,' # Positions 81-90 not yet defined'/
     +          10i2,3x,' # Positions 91-100 not yet defined'// )

      call iserclos ( 'iswrtif0' )
      end
