      subroutine isreadm4 ( ivers, stoper )
c ======================================================================
c
c
c        programmer     Guus Segal
c        version 1.0    date   21-06-94 (Subroutine extracted from the SEPRAN
c                                        subroutine READM4 version 1.2)
c
c
c
c   copyright (c) 1994  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c   Read second line in ISNaS environment file. This line contains the
c   version number of the file. Print a warning if the number is too low
c   If no version number is found the next line is interpreted
c ********************************************************************
c
c                      KEYWORDS
c
c   environment_file
c   read
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      character *(*) stoper
      integer ivers

c    ivers    o   Version number of environment file
c    stoper   o   Type of operating system
c ********************************************************************
c
c                      COMMON BLOCKS
c
      include 'IScommon/csepch'
      include 'IScommon/cseprd'
c ********************************************************************
c
c                    LOCAL PARAMETERS
c
      integer jcolum

c    jcolum     Column number for printing
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c     ISASKNXT  Read next item from the standard input file
c     ISREADCD  Read next card
c ********************************************************************
c
c                    I/O
c
c    none
c ********************************************************************
c
c                    ERROR MESSAGES
c
c   Error:    No colon found
c   Warning:  Old version of SEPRAN environment file
c ********************************************************************
c
c                    PSEUDO CODE
c
c      Read next record (comments excluded):  ISREADCD
c      Find colon
c      Read item after colon
c      If ( item = real ) then
c         version number found
c         if ( version number too small ) give warning
c         Store version number into ivers
c      else ( item = text ) then
c         give warning
c         ivers := 1
c         stoper := text
c ======================================================================
c
c     --- Read record (Do not translate into capitals)

      ispecl = 7
      ityprd = 1
      call isreadcd
      ispecl = 6

c     --- Find colon

      jcolum = index ( cards(kcolum:80), ':' )
      if ( jcolum.eq.0 ) then

c     --- No colon found:

         write(*,100) (cards(kcolum:80))
100      format ( ' Line in the environment file does not contain a',
     +            ' colon(:). '//' Execution is terminated'//
     +            ' The line read is:'/1x,a )
         stop

      end if
      jcolum = jcolum + kcolum
      kcolum = jcolum
      icolum = jcolum

      if ( jcolum.le.80 ) then

         ityprd = 4
         call isasknxt

      else

         ityprd = 4

      end if

      if ( ityprd.eq.2 .or. ityprd.eq.3 ) then

c     --- Version number found after colon
c         Check this number

         ivers = realrd
         if ( ivers.gt.1 ) then

c        --- ivers > 1

            write(*,110) ivers, 1, cards
110         format(//' The version number found in the environment',
     +               ' file is ', i3,' whereas the present version',
     +               ' should be at most', i2//
     +               ' The line read in the environment file is:'//a//
     +               ' Execution is terminated' )
            stop

         else if ( ivers.lt.1 ) then

c        --- ivers < 1

            write(*,120) ivers, 1, cards
120         format(//' The version number found in the environment',
     +               ' file is ', i3,' whereas the present version',
     +               ' should be', i2//
     +               ' The line read in the environment file is:'//a//
     +               ' Update your environment file as soon as',
     +               ' possible'// )

         end if

      else

         ivers = 1
         write(*,130) 1
130      format(//' No version number found in the environment',
     +            ' file, whereas the present version should be',i2//
     +            ' Update your environment file as soon as',
     +            ' possible'// )

         stoper = ' '
         if ( jcolum.le.80 ) stoper(1:80-jcolum+1) = cards(jcolum:80)

      end if

c     --- Fill text


      end
