      subroutine isreadqt
c ======================================================================
c
c
c        programmer     Guus Segal
c        version 1.0    date   21-06-94 (Subroutine extracted from the SEPRAN
c                                        subroutine READQT version 1.2)
c
c
c
c   copyright (c) 1994  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c ********************************************************************
c
c                         DESCRIPTION
c
c   read a text from the input file
c
c       This subroutine supposes that the parameter ICOLUM indicates the
c       first position of the text. This first position is a quote
c
c        a text is a number of symbols between quotes
c
c       After reading the text, icolum points to the next position to be read
c
c ********************************************************************
c
c                      KEYWORDS
c
c  read_cards
c ********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none

c ********************************************************************
c
c                      COMMON BLOCKS
c
      include 'IScommon/csepch'
      include 'IScommon/cseprd'
c ********************************************************************
c
c                    LOCAL PARAMETERS
c
      logical ready

c    ready    Indicates if a while loop is finished or not
c ********************************************************************
c
c             SUBROUTINES CALLED
c
c     ISERCLOS  Resets old name of previous subroutine of higher level
c     ISEROPEN  Produces concatenated name of local subroutine
c     ISERRCHR  Puts values of strings in character error array
c     ISERRCRD  Prints the last record read and underlines the erroneous part
c     ISERRSUB  Error messages
c ********************************************************************
c
c                    I/O
c
c    none
c ********************************************************************
c
c                    ERROR MESSAGES
c
c    1333  No end text quote found
c ********************************************************************
c
c                    PSEUDO CODE
c
c   ready  := false
c   error  := false
c   nchar  := 0
c   kcolum := icolum
c   icolum := icolum+1
c
c   while ( not ready ) do
c      nchar := nchar+1
c      string(nchar) := cards(icolum)
c      icolum := icolum+1
c      if ( icolum > 81 ) then
c         ready := true
c         error := true
c      else if ( string(nchar) # ' ) then
c         ready := true
c   nchar = nchar-1
c ======================================================================
c
c     --- Initialize some parameters

      ready  = .false.
      nchar  = 0
      kcolum = icolum
      icolum = icolum + 1

100   if ( .not. ready ) then

c     --- First while loop for mantises

         nchar = nchar + 1
         string(nchar:nchar) = cards(icolum:icolum)
         icolum = icolum + 1
         if ( icolum.gt.81 ) then

c        --- End of record reached, without finding an end quote

            call iseropen ( 'isreadqt' )
            call iserrchr ( string(1:nchar), 1 )
            call iserrsub ( 1333, 0, 0, 1 )
            call iserrcrd
            call iserclos ( 'isreadqt' )
            go to 1000

         else if ( string(nchar:nchar).eq.'''' ) then

c        --- End quote found, end of text

            ready = .true.

         end if
         go to 100

      end if

c     --- End of while loop

1000  nchar = nchar - 1
      ityprd = 5
      end
