      subroutine uspcompinten(rho,T,e)
c ======================================================================
c
c        programmer     Philipe Reynier
c        version 1.0    date 06-07-1999
c
c
c   copyright (c) 1999-1999  "TU Delft"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "TU Delft".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c    Sample user subroutine to calculate the internal energy by point
c    This subroutine computes e for each point.
c    e is supposed to be a function of T and rho
c **********************************************************************
c
c                       KEYWORDS
c
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      double precision rho, T, e, a, b, c, rk2, R, rn, pphiint

c     e              o    internal energy
c     rho            i    density
c     t              i    temperature

c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS

      integer k

c     k              General loop variable
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c   uscoefhydr
c   uspcompphiint
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      call uscoefhydr(a,b,c,rk2,R,rn)
      call uspcompphiint(T,pphiint)

c     --- calculation of the internal energy

      e = rk2 + pphiint -  c*(rn +1d0)/((T**rn)*(1d0/rho + b))
      end
