      subroutine isexitpm
c ======================================================================
c
c        Programmer     Guus Segal
c        version 2.2    date 23-11-1998 Jason:  wrapper for MPI_FINALIZE
c        version 2.1    date 13-11-1998 Jason:  removed error checking
c        version 2.0    date 22-07-1998 Jason:  MPI version
c        version 1.1    date 26-09-1994 (Correction call to pvmfperror)
c        version 1.0    date 11-04-1994
c
c
c     copyright (c) 1994  "TU-Delft"
c     Permission to copy or distribute this software or documentation
c     in hard copy or soft copy granted only by written license
c     obtained from "TU-Delft"
c     All rights reserved. No part of this publication may be
c     reproduced, stored in a retrieval system (e.g., in memory, disk,
c     or core) or be transmitted by any means, electronic, mechanical,
c     photocopy, recording, or otherwise, without written Permission
c     from the publisher.
c
c **********************************************************************
c
c                       DESCRIPTION
c
c     Exit parallel application at node or host
c     Wrapper for MPI_Finalize
c **********************************************************************
c
c                       KEYWORDS
c
c     exit
c     parallel
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
c **********************************************************************
c
c                       COMMON BLOCKS
c
      include 'IScommon/cisparal'

c **********************************************************************
c
c                       LOCAL PARAMETERS
c
cpar      include 'mpif.h'
      integer ierr

c     ierr      Return code of a subroutine 
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     MPI_FINALIZE  cleans up the MPI state and exits
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c     call MPI_FINALIZE
c **********************************************************************
c
c                       MODULES USED
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
cpar      call MPI_FINALIZE ( ierr )

      end
