      subroutine isiniclk
c ======================================================================
c
c        programmer     Guus Segal
c        version 1.3    date   02-03-1999 Gary: adapted for Fujitsu VPP700
c        version 1.2    date   23-04-1996 Guus: initialize cistime
c        version 1.1    date   11-12-1995 Kees K declaration of second
c        version 1.0    date   26-01-1994 Extracted from the SEPRAN subroutine
c                                         iniclk version 2.5
c
c
c   copyright (c) 1994-1999  "Ingenieursbureau SEPRA"
c   permission to copy or distribute this software or documentation
c   in hard copy or soft copy granted only by written license
c   obtained from "Ingenieursbureau SEPRA".
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   publisher.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c      set time parameter to zero
c      machine dependent subroutine
c      This subroutine is machine dependent
c **********************************************************************
c
c                       KEYWORDS
c
c     time
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none

c ********************************************************************
c                    COMMON BLOCKS
      include 'IScommon/cistime'
      common /cdctim/ tim1
      save /cdctim/
      real tim1

c                 /cdctim/
c     Keep the initial time
c     tim1    o   Time at call of iniclk
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer i

cray      real    second
cvpp      real    second
cybr      real    second
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c     ISSETTIM  Unix time initialization written in c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
c     --- General time subroutine in various versions available
c         For some computers local

cuni      call issettim

c     --- IBM PC 80386 + FTN77/386 compiler version

cipc      call clock@ ( tim1 )

c     --- VAX version

cvax      tim1 = secnds(0e0)

c     --- Cyber version

cybr      tim1 = second()

c     --- Cray version

cray      tim1 = second()

c     --- Fujitsu VPP700 version

cvpp      tim1 = second()

c     --- Initialize cistime

      do i = 1, maxtime
         time(i) = 0d0
      end do

      end
